<?php defined('SYSPATH') || die('No direct script access.');

/**
 * Class Model_Semesters
 *
 * @property int ID
 * @property int Num
 * @property int Year
 * @property string Season
 */
class Model_Logs extends Model
{
    public static function load()
    {
        $query = 'SELECT * FROM GetSignInHistory(50)';
        return DB::query(Database::SELECT, $query)->execute()->as_array();
    }

    public static function logFormDownload($accountID, $disciplineID, $stage, $locked) {
        $query = 'SELECT * FROM log_form_download(:account, :discipline, :stage, :locked)';

        $result = DB::query(Database::UPDATE, $query)
            ->param(':account', $accountID)
            ->param(':discipline', $disciplineID)
            ->param(':stage', $stage)
            ->param(':locked', $locked)
            ->execute();
        return $result;
    }

    public static function logSigninDetailed($accountID, $isStaff, $isStudent, $globalKey, $studentId, $errorMessage) {
        $query = 'SELECT * FROM log_sigindetailed(:account, :isstaff, :isstudent, :globalkey, :errormessage)';

        $message = 'studentID='.$studentId.'. Message: '.$errorMessage;
        $result = DB::query(Database::UPDATE, $query)
            ->param(':account', $accountID)
            ->param(':isstaff', $isStaff)
            ->param(':isstudent', $isStudent)
            ->param(':globalkey', $globalKey)
            ->param(':errormessage', $message)
            ->execute();
        return $result;
    }


    public static function logFormExport($accountID, $disciplineID, $groupID, $semesterID, $error = 0) {
        $query = 'SELECT * FROM LogFormExport(:account, :discipline, :group, :semester, :error)';

        $result = DB::query(Database::UPDATE, $query)
            ->param(':account', $accountID)
            ->param(':discipline', $disciplineID)
            ->param(':group', $groupID)
            ->param(':semester', $semesterID)
            ->param(':error', $error)
            ->execute();
        return $result;
    }

    public static function logDisciplineActivations($accountID, $disciplineID, $isActive) {
        $query = 'SELECT * FROM LogDisciplineDeactivation(:account, :discipline)';
        if ($isActive) {
            $query = 'SELECT * FROM LogDisciplineActivation(:account, :discipline)';
        }

        $result = DB::query(Database::UPDATE, $query)
            ->param(':account', $accountID)
            ->param(':discipline', $disciplineID)
            ->execute();
        return $result;
    }

    public static function setLastFormExportError($disciplineID, $groupID, $semesterID, $error) {
        $query = 'SELECT * FROM SetLastFormExportError(:discipline, :group, :semester, :error)';

        $result = DB::query(Database::UPDATE, $query)
            ->param(':discipline', $disciplineID)
            ->param(':group', $groupID)
            ->param(':semester', $semesterID)
            ->param(':error', $error)
            ->execute();
        return $result;
    }

}
